library(TSA)

######### Example 1

par(mfrow=c(3,1))
phi1<-0.9;phi2<--0.8
set.seed(1004)
y<-arima.sim(n=200,list(order=c(2,0,0),ar=c(phi1,phi2)),
sd=1.0,rand.gen=rnorm)
plot(y,main=bquote(Y[t]==.(phi1)*Y[t-1]~.(phi2)*Y[t-2]+epsilon[t]))
acf(y,ylab="Sampleautocorr.function",main="")
perio<-periodogram(y,ylab="Rawperiodogram")
abline(h=0)
par(mfrow=c(1,1))


######### Example 2

set.seed(1001)
x<-rep(0,100);eps<-rnorm(100)
for (t in 2:100) x[t]<-0.6*x[t-1]+eps[t]
y=lag(x,-4)+0.5*rnorm(100)
a<-ccf(x,y,ylab="cross-covariance",type="covariance")
b<-ccf(x,y,ylab="cross-correlation",type="correlation")
ccf(x,y)[-4] # 0.937


######### Example 3

data(boardings)
y1<-log.boardings<-boardings[,1]
y2<-log.price<-boardings[,2]
par(mfrow=c(1,2))
plot(y2,type="l",main="log.price")
abline(v=c(2001,2002,2003,2004,2005,2006),lty=2,col="red")
plot(y1,type="l",main="log.boardings")
abline(v=c(2001,2002,2003,2004,2005,2006),lty=2,col="red")
y1dif<-diff(y1);y2dif<-diff(y2)

######### Example 4 

y1<-log.boardings<-boardings[,1]
y2<-log.price<-boardings[,2]
y1dif<-diff(y1);y2dif<-diff(y2)
par(mfrow=c(1,2))
require(TSA)
per_p_dif<-periodogram(y2dif,ylab="dif. of log.price spectrum")
per_b_dif<-periodogram(y1dif,ylab="dif. of log.boardings spectrum")
                                           

kernD2<-kernel("modified.daniell",c(2,2)) # 9 weights kernel
# 0.01563 0.062500.12500 0.18750 0.21875 0.18750
# 0.12500 0.06250 0.01563
spec.pgram(y2dif,kernD2,tape=0,log="no",main="dif. of log.price spectrum, L=9")
spec.pgram(y1dif,kernD2,tape=0,log="no",main="dif. of log.boardings spectrum, L=9")


prbd<-spec.pgram(cbind(y2dif,y1dif),kernel("daniell",4),taper=0,plot=FALSE)
prbd$df # 16.75
f<-qf(0.995,2,prbd$df-2) # 7.75 fractile for F with 2 and (df-2)
C<-f/(12+f) # 0.39
n<-length(y1dif) ; np<-nextn(n) # n=67, np=72, df=2Ln/np=2∗13∗67/72=24.19444
par(mfrow=c(1,1))
plot(prbd,plot.type="coh",ci.lty=2,main="K^2(XY),X=dif.log.price,Y=dif.log.boardings")
abline(h=C)





